/**********************************************************
 * Autor: Carlos Fernando B. Cruz                         *
 **********************************************************/

#include <stdio.h>
#include <dos.h>
#include <conio.h>
#include <bios.h>
#include <janela.h>

/***********************************************************
 *   Executa a movimentacao do cursor e a documentacao  da *
 * sua posicao no canto inferior da tela.                  *
 ***********************************************************/

void gerencie_cursor (int coluna, int linha)

  {
     gotoxy (25, 25);
     printf ("(%d, %d)  ", coluna, linha);
     gotoxy (coluna, linha);
  }

/***********************************************************
 *   Espera por uma entrada pelo teclado e executa durante *
 *  a espera,  um  monitoramento  das  teclas  Scrool Lock,*
 *  Num Lock, Caps Lock, Ins.                              *
 ***********************************************************/

int entre_caracter ()

  {

     char far *tela = MK_FP (0xB000, 0x8000); /* Apontador de char no video  */
     int biosmodificado = 0;                  /* Byte de status anterior     */

     while (bioskey (1) == 0)                 /* Ha caracter no buffer?      */
       {
          if (bioskey (2) != biosmodificado)  /* Modilficou o byte de status?*/
            {
              biosmodificado = bioskey (2);   /* Atualiza byte status anter. */
              if ((biosmodificado & 16) == 16)/* Qual a situacao do SCROOL?  */
                {
                  tela [3988] = 'S';
                  tela [3990] = 'c';
                  tela [3992] = 'r';
                  tela [3994] = 'o';
                  tela [3996] = 'o';
                  tela [3998] = 'l';
                }
              else
                {
                  tela [3988] = ' ';
                  tela [3990] = ' ';
                  tela [3992] = ' ';
                  tela [3994] = ' ';
                  tela [3996] = ' ';
                  tela [3998] = ' ';
                }
              if ((biosmodificado & 32) == 32)/* Qual a situacao do NUM?     */
                {
                  tela [3980] = 'N';
                  tela [3982] = 'u';
                  tela [3984] = 'm';
                }
              else
                {
                  tela [3980] = ' ';
                  tela [3982] = ' ';
                  tela [3984] = ' ';
                }
              if ((biosmodificado & 64) == 64)/* Qual a situacao do CAPS?    */
                {
                  tela [3970] = 'C';
                  tela [3972] = 'a';
                  tela [3974] = 'p';
                  tela [3976] = 's';
                }
              else
                {
                  tela [3970] = ' ';
                  tela [3972] = ' ';
                  tela [3974] = ' ';
                  tela [3976] = ' ';
                }
              if ((biosmodificado & 128) == 128)/* Qual a situacao do INS?   */
                {
                  tela [3962] = 'I';
                  tela [3964] = 'n';
                  tela [3966] = 's';
                }
              else
                {
                  tela [3962] = ' ';
                  tela [3964] = ' ';
                  tela [3966] = ' ';
                }
            }
       }         /* Sai do while se existe um caracter no buffer de teclado. */
     return (bioskey (0)); /* Le, deleta e retorna o caracter do buffer */
  }

/***********************************************************
 *   Abre uma janela para  a  escolha  da  moldura,  dando *
 * condicoes de movimentacao da  janela  caso  ela  esteja *
 * atrapalhando oque foi coberto por ela.                  *
 ***********************************************************/


char escolha_moldura ()

  {
     struct janela *j = NULL; /* Inicio da pilha da janela de moldura.       */
     int inteiro = 0,         /* Contem o caracter do mov.do (cursor/janela).*/
         linha,               /* Contem a linha do cursor.                   */
         coluna,              /* Contem a coluna do cursor.                  */
         variar = 1,          /* Varia as culunas dos caracteres na janela.  */
         jlinha = 1,          /* Contem a linha superior da janela.          */
         jcoluna = 1;         /* Contem a coluna esquerda da janela.         */
     char caracter = (char) 0,/* Recebe da tela o caracter escolhido.        */
     far *tela = MK_FP (0xB000, 0x8000);/* Apontador para caracter no video  */


    /*************************************************************************
     * Forma a janela de escolha de caracteres especiais de video            *
     *************************************************************************/

     j = salve_janela (1, 1, 38, 20, j);
     window (1, 1, 38, 20);
     textbackground (4);
     clrscr ();
     textbackground (0);
     window (1, 1, 80, 25);
     moldura (1, 1, 38, 20, j, 1, 1, 0);
     for (linha = 0; linha < 16; linha++)
       {
          for (coluna = 0; coluna < 16; coluna++)
            {
              gotoxy ((coluna+2)*2+variar, linha+3);
              if (caracter != (char) 7)
                printf ("%c",caracter++);
              else
                caracter++;
             }
          if (variar == 1)
            variar = 0;
          else
            variar++;
       }
     gerencie_cursor (coluna = 20, linha = 10);

    /*************************************************************************
     *    Enquanto nao foi feita a escolha do caracter por intermedio do     *
     * <Enter>, continue gerenciando o movimento do cursor e da janela.      *
     *************************************************************************/

     do
       {
          inteiro = entre_caracter ();
          switch (inteiro)
            {
              case 18432:                       /* Comando para subir.       */
                if ((bioskey (2) & 16) == 16)   /* Se SCROOL ligado,         */
                  {                             /* suba a janela.            */
		    j = mova_janela (SUBIR, 1, j);
                    if (jlinha != 1)            /* A janela subiu ?          */
                      {                         /* Se sim entao atualize ind.*/
                        jlinha--;
                        linha--;
                      }
                    gerencie_cursor (coluna, linha);
                  }
                else                            /* Se SCROOLS desligado,     */
                  {                             /* suba o cursor,            */
                     if (linha != jlinha+2)     /* se for possivel.          */
                       linha--;
                     gerencie_cursor (coluna, linha);
                  }
                break;
              case 20480:                       /* Comando para descer.      */
                if ((bioskey (2) & 16) == 16)   /* Se SCROOL ligado,         */
                  {                             /* desca a janela.           */
		    j = mova_janela (DESCER, 24, j);
                    if (jlinha != 5)            /* A janela desceu?          */
                      {                         /* Se sim atualize indices.  */
                        jlinha++;
                        linha++;
                      }
                    gerencie_cursor (coluna, linha);
                  }
                else                            /* Se SCROOL desligado,      */
                  {                             /* desca o cursor,           */
                     if (linha != jlinha+17)    /* se for possivel.          */
                       linha++;
                     gerencie_cursor (coluna, linha);
                  }
                break;
              case 19200:                       /* Comando para esquerda.    */
                if ((bioskey (2) & 16) == 16)   /* Se SCROOL ligado,         */
                  {                             /* Mova a janela para a esq. */
		    j = mova_janela (ESQUERDA, 1, j);
                    if (jcoluna != 1)           /* Se foi possivel ir para a */
                      {                         /* esquerda entao atualize os*/
                        jcoluna--;              /* indices.                  */
                        coluna--;
                      }
                    gerencie_cursor (coluna, linha);
                  }
                else                            /* Se SCROOL desligado,      */
                  {                             /* mova o cursor para a      */
                     if (coluna != jcoluna+3)   /* esquerda se for possivel. */
                       coluna--;
                     gerencie_cursor (coluna, linha);
                  }
                break;
              case 19712:                       /* Comando para a direita    */
                if ((bioskey (2) & 16) == 16)   /* Se SCROOL ligado,         */
                  {                             /* mova a janela para a dir. */
		    j = mova_janela (DIREITA, 80, j);
                    if (jcoluna != 43)          /* Se a janela andou, entao  */
                      {                         /* atualize os indices.      */
                        jcoluna++;
                        coluna++;
                      }
                    gerencie_cursor (coluna, linha);
                  }
                else                            /* Se SCROOL desligado,      */
                  {                             /* mova o cursor para a dir. */
                     if (coluna != jcoluna+34)  /* se for possivel.          */
                       coluna++;
                     gerencie_cursor (coluna, linha);
                  }
                break;
              case 7181: /* Comando para indicar escolha de caract.no video  */
                         /* atravez da tecla <Enter>.                        */
                caracter = tela [(((linha-1)*80+coluna-1)*2)]; /* transfira. */
                break;
            }
       } while ((inteiro != 283) && (inteiro != 7181));

     feche_janela (j);                       /* Feche janela de moldura      */

     return (caracter);                      /* Retorne a moldura escolhida  */
  }

/***********************************************************
 *   Gerencia toda a movimentacao do cursor assim  como  a *
 * rolagem da tela,  proporcionado  um  ambiente rapido  e *
 * agil com o auxilio de recursos tais como o  de  iserir, *
 * deletar e outros.                                       *
 ***********************************************************/

void faca_tela (char *arquivo)

  {
     int contador,         /* Contador normal para uso interno.              */
         confirmacao = 0,  /* Confirmacao de saida e salvamento da tela.     */
         rotlinha,         /* Indice de linha para rotacao da tela.          */
         rotcoluna,        /* Indice de coluna para rotacao da tela.         */
         atributo = 48,    /* Atributo da linha inferior da tela.            */
         inteiro,          /* Contem o comando para movim.do (cursor/tela).  */
         linha = 1,        /* Indice da linha corrente do cursor.            */
         coluna = 1,       /* Indice da coluna corrente do cursor.           */
         coloc_sim_nao = 0;/* Indice para colocar o atributo no local certo. */

     struct janela *j=NULL;/* Inicio da pilha de janela, comecando pela tela */
                           /* inicial do usuario.                            */
     char charmoldura,     /* Guarda o caracter escolhido para ser moldura.  */
          ascii;           /* Recebe o caracter para ser colocado no video.  */

     char far *tela = MK_FP (0xB000, 0x8000), /* Apontador de caracter para  */
                                              /* a tela de video.            */
          fim_tela [80];                      /* Cadeia de caracteres que    */
                                              /* auxilia na rotacao da tela. */



    /*************************************************************************
     * Preenche a linha inferior com o atributo de numero 45.                *
     *************************************************************************/

     clrscr ();
     for (contador=3840; contador < 4000; contador++)
       if (coloc_sim_nao == 1)
         {
           tela [contador] = (char) atributo;
           coloc_sim_nao = 0;
         }
       else
         coloc_sim_nao = 1;

    /*************************************************************************
     * Coloca os indicadores do cursor e arquivo atual na linha de rodape.   *
     *************************************************************************/

     gotoxy (17, 25);
     printf ("Cursor: ");
     gotoxy (35, 25);
     printf ("Arquivo: %-1.12s", arquivo);
     gerencie_cursor (coluna, linha);

    /*************************************************************************
     * Enquanto nao foi dada a confirmacao de saida e salvamento, nao saia.  *
     *************************************************************************/

     while (confirmacao != 1)
       {

    /*************************************************************************
     * Continue trabalhando enquanto nao foi pressionado a tecla <Esc>.      *
     *************************************************************************/

         while ((inteiro = entre_caracter ()) != 283)
           {
             switch (inteiro)
               {
                 case 18432:                     /* Comando para subir       */
                   if ((bioskey (2) & 16) == 16) /* Se SCROOL ligado         */
                     {                           /* suba a tela inteira.     */
                       for (contador = 0; contador < 80; contador++)
                         fim_tela [contador] = tela [contador*2];
                       for (rotlinha = 0; rotlinha < 23; rotlinha++)
                         for (rotcoluna = 0; rotcoluna < 80; rotcoluna++)
                           tela [(rotlinha*80+rotcoluna)*2] =
                             tela [((rotlinha+1)*80+rotcoluna)*2];
                       for (contador = 0; contador < 80; contador++)
                         tela [(1840+contador)*2] = fim_tela [contador];
                     }
                   if (linha != 1)               /* Suba o cursor independen-*/
                     linha--;                    /* temente do SCROOL LOCK   */
                   gerencie_cursor (coluna, linha);
                   break;
                 case 20480:                     /* Comando para descer.     */
                   if ((bioskey (2) & 16) == 16) /* Se SCROOL ligado desca a */
                     {                           /* tela inteira.            */
                       for (contador = 0; contador < 80; contador++)
                         fim_tela [contador] = tela [(1840+contador)*2];
                       for (rotlinha = 23; rotlinha > 0; rotlinha--)
                         for (rotcoluna = 0; rotcoluna < 80; rotcoluna++)
                           tela [(rotlinha*80+rotcoluna)*2] =
                             tela [((rotlinha-1)*80+rotcoluna)*2];
                       for (contador = 0; contador < 80; contador++)
                         tela [contador*2] = fim_tela [contador];
                     }
                   if (linha != 24)               /* Desca o cursor sem olhar*/
                     linha++;                     /* para o SCROOL LOCK.     */
                   gerencie_cursor (coluna, linha);
                   break;
                 case 19200:                      /* Comando para esquerda.  */
                   if ((bioskey (2) & 16) == 16)  /* Se SCROOL ligado role a */
                     {                            /* tela para a esquerda.   */
                       for (contador = 0; contador < 24; contador++)
                         fim_tela [contador] = tela [contador*160];
                       for (rotlinha = 0; rotlinha < 24; rotlinha++)
                         for (rotcoluna = 0; rotcoluna < 79; rotcoluna++)
                           tela [(rotlinha*80+rotcoluna)*2] =
                             tela [(rotlinha*80+rotcoluna+1)*2];
                       for (contador = 0; contador < 24; contador++)
                         tela [contador*160+158] = fim_tela [contador];
                     }
                   if (coluna != 1)               /* Mova o cursor p/ a esq. */
                     coluna--;                    /* se for possivel.        */
                   gerencie_cursor (coluna, linha);
                   break;
                 case 19712:                      /* Comando para direita.   */
                   if ((bioskey (2) & 16) == 16)  /* Se SCROOL ligado role a */
                     {                            /* tela para a direita.    */
                       for (contador = 0; contador < 24; contador++)
                         fim_tela [contador] = tela [contador*160+158];
                       for (rotlinha = 0; rotlinha < 24; rotlinha++)
                         for (rotcoluna = 78; rotcoluna >= 0; rotcoluna--)
                           tela [(rotlinha*80+rotcoluna+1)*2] =
                             tela [(rotlinha*80+rotcoluna)*2];
                       for (contador = 0; contador < 24; contador++)
                         tela [contador*160] = fim_tela [contador];
                     }
                   if (coluna != 80)              /* Mova o cursor p/ a dir. */
                     coluna++;                    /* se for possivel.        */
                   gerencie_cursor (coluna, linha);
                   break;
                 case 3592:                       /* Execute BackSpace.      */
                   if (linha != 1 || coluna != 1)
                     {
                       coluna--;
                       tela [((linha-1)*80+coluna-1)*2] = ' ';
                       if (coluna == 0)
                         {
                           coluna = 80;
                           linha--;
                         }
                       gerencie_cursor (coluna, linha);
                     }
                     break;
                 case 7181:                       /* Chame funcao p/ escolha */
                                                  /* da moldura.             */
                   charmoldura = escolha_moldura ();
                   gotoxy (3, 25);
                   printf ("Moldura: [%c]", charmoldura);
                   gerencie_cursor (coluna, linha);
                   break;
                 case 21248:                     /* Execute Del dentro dos   */
                   if (linha != 1 || coluna != 1)/* limites da tela.         */
                     if (coluna != 1)
                       {
                         coluna--;
                         tela [((linha-1)*80+coluna-1)*2] = ' ';
                         for (contador = coluna; contador < 80; contador++)
                           tela [((linha-1)*80+contador-1)*2] =
                             tela [((linha-1)*80+contador)*2];
                         tela [((linha-1)*80+79)*2] = (char) 32;
                         gerencie_cursor (coluna, linha);
                       }
                     break;
                 case 3849:                      /* Coloque a moldura.       */
                   if ((bioskey (2) & 128) == 128)/* Insira se Ins ligado.   */
                     {
                       for (contador = 78; contador >= (coluna-1); contador--)
                         tela [((linha-1)*80+contador+1)*2] =
                           tela [((linha-1)*80+contador)*2];
                       tela [((linha-1)*80+coluna-1)*2] = charmoldura;
                       coluna++;
                       gerencie_cursor (coluna, linha);
                     }
                   else                          /* Insira a moldura normalm.*/
                     {
                       tela [((linha-1)*80+coluna-1)*2] = charmoldura;
                       coluna++;
                       gerencie_cursor (coluna, linha);
                     }
                 default:                        /* Coloque o caracter nao  */
                   if (inteiro != 3849)          /* especial.               */
                     if (((bioskey (2) & 128) == 128) &&
                        ((char) inteiro != (char) 0)) /* Ins Ligado?        */
                       {                              /* Sim, Insira.       */
                         for (contador = 78; contador >= (coluna-1); contador--)
                           tela [((linha-1)*80+contador+1)*2] =
                             tela [((linha-1)*80+contador)*2];
                         ascii = (char) inteiro; /* Converta int => char    */
                         tela [((linha-1)*80+coluna-1)*2] = ascii;
                         coluna++;
                         gerencie_cursor (coluna, linha);
                       }
                     else                       /* Ins desligado, sobreponha.*/
                       if ((char) inteiro != (char) 0x0)
                         {
                           ascii = (char) inteiro;
                           tela [((linha-1)*80+coluna-1)*2] = ascii;
                           coluna++;
                           gerencie_cursor (coluna, linha);
                         }
                   if (coluna == 81)           /* Se utrapassou coluna volte */
                       coluna = 80;
                   if (linha == 25)            /* Se utrapassou linha volte  */
                     linha = 24;
                   gerencie_cursor (coluna, linha);
               }
           }

    /*************************************************************************
     * Comfirme a opcao de saida com save da tela.                           *
     *************************************************************************/

	 j = salve_janela (1, 1, 14, 3, j);
         window (1, 1, 14, 3);
         textbackground (4);
         clrscr ();
         textbackground (0);
	 moldura (1, 1, 14, 3, j, 1, 1, 0);
         window (1, 1, 80, 25);
         gotoxy (2, 2);
	 printf ("Sair (S/N):");
         confirmacao = bioskey (0);
         if (((char) confirmacao == 'S') || ((char) confirmacao == 's'))
           confirmacao = 1;
         feche_janela (j);
         gerencie_cursor (coluna, linha);
       }
  }

/***********************************************************
 *   Executa e avalia  o  intercambio  com  o  usuario  na *
 * chamada do programa e gera o arquivo presente  na  tela *
 * de video                                                *
 ***********************************************************/

main (int argc, char *argv [])       /*  Interface com o usuario.            */

  {
     struct janela *j = NULL;        /*  Ponteiro para a pilha de janelas.   */
     int salvo_cursorx = wherex (),  /*  Salva posicao X do cursor.          */
         salvo_cursory = wherey ();  /*  Salva posicao Y do cursor.          */
     unsigned int linha,             /*  Indice de linha de gravacao da tela.*/
                  coluna,            /*  Indice de coluna de grav. da tela.  */
                  far *tela = MK_FP (0xB000, 0x8000); /* Pont.p/ u.i na tela.*/
     FILE *arq_saida = NULL;         /*  Ponteiro para arquivo de saida.     */
     if (argc != 2)                  /*  Rejeite entrada menor que 1 paramet.*/
       {
         printf ("ERRO - Chamar 'ARQTEL [arqsaida]'.");
         exit (1);
       }
     if ((arq_saida = fopen (argv [1], "w")) == NULL) /* Abra Arquivo.       */
       {
         printf ("ERRO: Nao consegui abrir o arquivo de saida...");
         exit (1);
       }

    /*************************************************************************
     * Tela de informacao do nome do programa, arquivo de saida e autor.     *
     *************************************************************************/

     j = salve_janela (28, 5, 53, 9, j);
     window (28, 5, 53, 9);
     textbackground (4);
     clrscr ();
     textbackground (0);
     window (1, 1, 80, 25);
     moldura (28, 5, 53, 9, j, 1, 1, 0);
     gotoxy (30, 6);
     printf ("FORMATADOR DE TELAS");
     gotoxy (30, 7);
     printf ("Arq: %-1.12s",argv [1]);
     gotoxy (30, 8);
     printf ("Carlos Fernando B.Cruz");
     bioskey (0);
     j = feche_janela (j);
     j = salve_janela (1, 1, 80, 25, j);
     faca_tela (argv [1]);

    /*************************************************************************
     * Salve a tela no arquivo de saida.                                     *
     *************************************************************************/

     for (linha=0; linha < 24; linha++)
       {
         if (putc ((char) 123, arq_saida) == EOF)   /*   Abra chave '{'      */
           {
             feche_janela (j);
             gotoxy (salvo_cursorx, salvo_cursory);
             printf ("ERRO: Nao foi possivel salvar.");
             exit (1);
           }
         for (coluna=0; coluna < 80; coluna++)      /*  Salve a linha.       */
           if (putc ((char) tela [linha*80+coluna], arq_saida) == EOF)
             {
               feche_janela (j);
               gotoxy (salvo_cursorx, salvo_cursory);
               printf ("ERRO: Desculpe-me, mas nao consegui salvar a tela.");
               exit (1);
             }
         if (putc ((char) 125, arq_saida) == EOF)   /*  Feche a chave '}'    */
           {
             feche_janela (j);
             gotoxy (salvo_cursorx, salvo_cursory);
             printf ("ERRO: Nao foi possivel salvar a tela no disco.");
             exit (1);
           }
         if (putc ((char) 10, arq_saida) == EOF)    /*  Grave final de linha */
           {
             feche_janela (j);
             gotoxy (salvo_cursorx, salvo_cursory);
             printf ("ERRO: Nao foi possival gravar a tela no disco.");
             exit (1);
           }
       }
     feche_janela (j);                        /* Retorne tela do usuario.    */
     gotoxy (salvo_cursorx, salvo_cursory);   /* Volte a posicao cursor inic.*/
     fclose (arq_saida);                      /* Feche arquivo.              */
  }                                           /* Fim Arqtel.                 */

